library waypoints_events;

import 'package:sunny_sdk_core/model_exports.dart';
import 'package:sunny_service_stubs/models/waypoints_events/waypoints_events.dart';

import 'model/account_event.dart';
import 'model/entity_created_event.dart';
import 'model/entity_event.dart';
import 'model/entity_updated_event.dart';
import 'model/thread_status_changed_event.dart';
import 'model/user_task_created_event.dart';
import 'model/user_task_updated_event.dart';

export 'package:sunny_service_stubs/models/waypoints_events/waypoints_events.dart';

export 'ext/ext.dart';
export 'model/account_event.dart';
export 'model/entity_created_event.dart';
export 'model/entity_event.dart';
export 'model/entity_updated_event.dart';
export 'model/thread_status_changed_event.dart';
export 'model/user_task_created_event.dart';
export 'model/user_task_updated_event.dart';

const waypointsEventsModuleRef =
    MModuleRef.ofParts("sunny", "waypointsEvents", "0.0.1");

registerWaypoints_eventsModels(
    MModelRegistry modelRegistry, MEnumRegistry enumRegistry) {
  modelRegistry.register(
      AccountEventRef, (json) => AccountEvent(json as Map<String, dynamic>));
  IAccountEvent.of = AccountEvent.of;
  IAccountEvent.fromJson = AccountEvent.fromJson;

  modelRegistry.register(EntityCreatedEventRef,
      (json) => EntityCreatedEvent(json as Map<String, dynamic>));
  IEntityCreatedEvent.of = EntityCreatedEvent.of;
  IEntityCreatedEvent.fromJson = EntityCreatedEvent.fromJson;

  modelRegistry.register(
      EntityEventRef, (json) => EntityEvent(json as Map<String, dynamic>));
  IEntityEvent.of = EntityEvent.of;
  IEntityEvent.fromJson = EntityEvent.fromJson;

  modelRegistry.register(EntityUpdatedEventRef,
      (json) => EntityUpdatedEvent(json as Map<String, dynamic>));
  IEntityUpdatedEvent.of = EntityUpdatedEvent.of;
  IEntityUpdatedEvent.fromJson = EntityUpdatedEvent.fromJson;

  modelRegistry.register(ThreadStatusChangedEventRef,
      (json) => ThreadStatusChangedEvent(json as Map<String, dynamic>));
  IThreadStatusChangedEvent.of = ThreadStatusChangedEvent.of;
  IThreadStatusChangedEvent.fromJson = ThreadStatusChangedEvent.fromJson;

  modelRegistry.register(UserTaskCreatedEventRef,
      (json) => UserTaskCreatedEvent(json as Map<String, dynamic>));
  IUserTaskCreatedEvent.of = UserTaskCreatedEvent.of;
  IUserTaskCreatedEvent.fromJson = UserTaskCreatedEvent.fromJson;

  modelRegistry.register(UserTaskUpdatedEventRef,
      (json) => UserTaskUpdatedEvent(json as Map<String, dynamic>));
  IUserTaskUpdatedEvent.of = UserTaskUpdatedEvent.of;
  IUserTaskUpdatedEvent.fromJson = UserTaskUpdatedEvent.fromJson;
}
